diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/samples/unprocessed_raw.cpp libkdcraw/libkdcraw/libraw/samples/unprocessed_raw.cpp
--- libkdcraw-wrk/libkdcraw/libraw/samples/unprocessed_raw.cpp	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/samples/unprocessed_raw.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -1,156 +1,318 @@
-/*
+/* -*- C++ -*-
  * File: unprocessed_raw.cpp
- * Copyright 2009 Alex Tutubalin <lexa@lexa.ru>
+ * Copyright 2009-2020 LibRaw LLC (info@libraw.org)
  * Created: Fri Jan 02, 2009
  *
  * LibRaw sample
- * Generates unprocessed raw image: with masked pixels and without black subtraction
+ * Generates unprocessed raw image: with masked pixels and without black
+subtraction
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
  */
 #include <stdio.h>
 #include <string.h>
 #include <math.h>
-#ifndef WIN32
+#include <time.h>
+
+#include "libraw/libraw.h"
+
+#ifndef LIBRAW_WIN32_CALLS
 #include <netinet/in.h>
 #else
+#include <sys/utime.h>
 #include <winsock2.h>
 #endif
 
-#include "libraw/libraw.h"
-
-#ifdef WIN32
+#ifdef LIBRAW_WIN32_CALLS
 #define snprintf _snprintf
 #endif
 
+#if !(LIBRAW_COMPILE_CHECK_VERSION_NOTLESS(0, 14))
+#error This code is for LibRaw 0.14+ only
+#endif
+
+void gamma_curve(unsigned short curve[]);
+void write_ppm(unsigned width, unsigned height, unsigned short *bitmap,
+               const char *basename);
+void write_tiff(int width, int height, unsigned short *bitmap,
+                const char *basename);
+
 int main(int ac, char *av[])
 {
-    int  i, ret;
-    int verbose=1,autoscale=0;
-    char outfn[1024],thumbfn[1024]; 
-
-    LibRaw RawProcessor;
-    if(ac<2) 
-        {
-          usage:
-            printf(
-                "unprocessed_raw - LibRaw %s sample. %d cameras supported\n"
-                "Usage: %s [-q] [-A] [-g] [-s N] [-N] raw-files....\n"
-                "\t-q - be quiet\n"
-                "\t-s N - select Nth image in file (default=0)\n"
-                "\t-g - use gamma correction with gamma 2.2 (not precise,use for visual inspection only)\n"
-                "\t-A - autoscaling (by integer factor)\n"
-                "\t-N - no raw curve\n"
-                ,LibRaw::version(),
-                LibRaw::cameraCount(),
-                av[0]);
-            return 0;
-        }
-    
-#define P1 RawProcessor.imgdata.idata
+  int i, ret;
+  int verbose = 1, autoscale = 0, use_gamma = 0, out_tiff = 0;
+  char outfn[1024];
+
+  LibRaw RawProcessor;
+  if (ac < 2)
+  {
+  usage:
+    printf("unprocessed_raw - LibRaw %s sample. %d cameras supported\n"
+           "Usage: %s [-q] [-A] [-g] [-s N] raw-files....\n"
+           "\t-q - be quiet\n"
+           "\t-s N - select Nth image in file (default=0)\n"
+           "\t-g - use gamma correction with gamma 2.2 (not precise,use for "
+           "visual inspection only)\n"
+           "\t-A - autoscaling (by integer factor)\n"
+           "\t-T - write tiff instead of pgm\n",
+           LibRaw::version(), LibRaw::cameraCount(), av[0]);
+    return 0;
+  }
+
 #define S RawProcessor.imgdata.sizes
-#define C RawProcessor.imgdata.color
-#define T RawProcessor.imgdata.thumbnail
-#define P2 RawProcessor.imgdata.other
 #define OUT RawProcessor.imgdata.params
 
-    OUT.document_mode=2;
-    OUT.output_bps=16;
-    OUT.output_tiff=1;
-    OUT.user_flip=0;
-    OUT.no_auto_bright = 1;
-    OUT.filtering_mode=(LibRaw_filtering)( LIBRAW_FILTERING_NOBLACKS|LIBRAW_FILTERING_NOZEROES);
-    for (i=1;i<ac;i++)
-        {
-            if(av[i][0]=='-')
-                {
-                    if(av[i][1]=='q' && av[i][2]==0)
-                        verbose=0;
-                    else if(av[i][1]=='A' && av[i][2]==0)
-                        autoscale=1;
-                    else if(av[i][1]=='g' && av[i][2]==0)
-                        OUT.gamma_16bit=1;
-                    else if(av[i][1]=='N' && av[i][2]==0)
-                        OUT.filtering_mode=LIBRAW_FILTERING_NONE;
-                    else if(av[i][1]=='s' && av[i][2]==0)
-                        {
-                            i++;
-                            OUT.shot_select=atoi(av[i]);
-                        }
-                    else
-                        goto usage;
-                    continue;
-                }
-            int r,c;
-            if(verbose) printf("Processing file %s\n",av[i]);
-            if( (ret = RawProcessor.open_file(av[i])) != LIBRAW_SUCCESS)
-                {
-                    fprintf(stderr,"Cannot open %s: %s\n",av[i],libraw_strerror(ret));
-                    continue; // no recycle b/c open file will recycle itself
-                }
-            if(verbose)
-                {
-                    printf("Image size: %dx%d\nRaw size: %dx%d\n",S.width,S.height,S.raw_width,S.raw_height);
-                    printf("Margins: top=%d, left=%d, right=%d, bottom=%d\n",
-                           S.top_margin,S.left_margin,S.right_margin,S.bottom_margin);
-                }
-
-            if( (ret = RawProcessor.unpack() ) != LIBRAW_SUCCESS)
-                {
-                    fprintf(stderr,"Cannot unpack %s: %s\n",av[i],libraw_strerror(ret));
-                    continue;
-                }
-            if(verbose)
-                printf("Unpacked....\n");
-
-            if( (ret = RawProcessor.add_masked_borders_to_bitmap() ) != LIBRAW_SUCCESS)
-                {
-                    fprintf(stderr,"Cannot add mask data to bitmap %s\n",av[i]);
-                }
-            for(int r=0;r<S.iheight;r++)
-                for(c=0;c<S.iwidth;c++)
-                    RawProcessor.imgdata.image[r*S.iwidth+c][0] 
-                        = RawProcessor.imgdata.image[r*S.iwidth+c][RawProcessor.FC(r,c)];
-
-            P1.colors=1;
-            if(autoscale)
-                {
-                    unsigned max=0,scale;
-                    for(int j=0; j<S.iheight*S.iwidth; j++)
-                        if(max < RawProcessor.imgdata.image[j][0])
-                            max = RawProcessor.imgdata.image[j][0]; 
-                    if (max >0 && max< 1<<15)
-                        {
-                            scale = (1<<16)/max;
-                            if(verbose)
-                                printf("Scaling with multiplier=%d (max=%d)\n",scale,max);
-                            
-                            for(int j=0; j<S.iheight*S.iwidth; j++)
-                                RawProcessor.imgdata.image[j][0] *= scale;
-                        }
-                }
-            
-            if(OUT.shot_select)
-                snprintf(outfn,sizeof(outfn),"%s-%d.tiff",av[i],OUT.shot_select);
-            else
-                snprintf(outfn,sizeof(outfn),"%s.tiff",av[i]);
-
-            if(verbose) printf("Writing file %s\n",outfn);
-            if( LIBRAW_SUCCESS != (ret = RawProcessor.dcraw_ppm_tiff_writer(outfn)))
-                fprintf(stderr,"Cannot write %s: %s\n",outfn,libraw_strerror(ret));
-        }
-    return 0;
+  for (i = 1; i < ac; i++)
+  {
+    if (av[i][0] == '-')
+    {
+      if (av[i][1] == 'q' && av[i][2] == 0)
+        verbose = 0;
+      else if (av[i][1] == 'A' && av[i][2] == 0)
+        autoscale = 1;
+      else if (av[i][1] == 'g' && av[i][2] == 0)
+        use_gamma = 1;
+      else if (av[i][1] == 'T' && av[i][2] == 0)
+        out_tiff = 1;
+      else if (av[i][1] == 's' && av[i][2] == 0)
+      {
+        i++;
+        OUT.shot_select = av[i] ? atoi(av[i]) : 0;
+      }
+      else
+        goto usage;
+      continue;
+    }
+
+    if (verbose)
+      printf("Processing file %s\n", av[i]);
+    if ((ret = RawProcessor.open_file(av[i])) != LIBRAW_SUCCESS)
+    {
+      fprintf(stderr, "Cannot open %s: %s\n", av[i], libraw_strerror(ret));
+      continue; // no recycle b/c open file will recycle itself
+    }
+    if (verbose)
+    {
+      printf("Image size: %dx%d\nRaw size: %dx%d\n", S.width, S.height,
+             S.raw_width, S.raw_height);
+      printf("Margins: top=%d, left=%d\n", S.top_margin, S.left_margin);
+    }
+
+    if ((ret = RawProcessor.unpack()) != LIBRAW_SUCCESS)
+    {
+      fprintf(stderr, "Cannot unpack %s: %s\n", av[i], libraw_strerror(ret));
+      continue;
+    }
+
+    if (verbose)
+      printf("Unpacked....\n");
+
+    if (!(RawProcessor.imgdata.idata.filters ||
+          RawProcessor.imgdata.idata.colors == 1))
+    {
+      printf("Only Bayer-pattern RAW files supported, sorry....\n");
+      continue;
+    }
+
+    if (autoscale)
+    {
+      unsigned max = 0, scale;
+      for (int j = 0; j < S.raw_height * S.raw_width; j++)
+        if (max < RawProcessor.imgdata.rawdata.raw_image[j])
+          max = RawProcessor.imgdata.rawdata.raw_image[j];
+      if (max > 0 && max < 1 << 15)
+      {
+        scale = (1 << 16) / max;
+        if (verbose)
+          printf("Scaling with multiplier=%d (max=%d)\n", scale, max);
+
+        for (int j = 0; j < S.raw_height * S.raw_width; j++)
+          RawProcessor.imgdata.rawdata.raw_image[j] *= scale;
+      }
+    }
+    if (use_gamma)
+    {
+      unsigned short curve[0x10000];
+      gamma_curve(curve);
+      for (int j = 0; j < S.raw_height * S.raw_width; j++)
+        RawProcessor.imgdata.rawdata.raw_image[j] =
+            curve[RawProcessor.imgdata.rawdata.raw_image[j]];
+      if (verbose)
+        printf("Gamma-corrected....\n");
+    }
+
+    if (OUT.shot_select)
+      snprintf(outfn, sizeof(outfn), "%s-%d.%s", av[i], OUT.shot_select,
+               out_tiff ? "tiff" : "pgm");
+    else
+      snprintf(outfn, sizeof(outfn), "%s.%s", av[i], out_tiff ? "tiff" : "pgm");
+
+    if (out_tiff)
+      write_tiff(S.raw_width, S.raw_height,
+                 RawProcessor.imgdata.rawdata.raw_image, outfn);
+    else
+      write_ppm(S.raw_width, S.raw_height,
+                RawProcessor.imgdata.rawdata.raw_image, outfn);
+
+    if (verbose)
+      printf("Stored to file %s\n", outfn);
+  }
+  return 0;
+}
+
+void write_ppm(unsigned width, unsigned height, unsigned short *bitmap,
+               const char *fname)
+{
+  if (!bitmap)
+    return;
+
+  FILE *f = fopen(fname, "wb");
+  if (!f)
+    return;
+  int bits = 16;
+  fprintf(f, "P5\n%d %d\n%d\n", width, height, (1 << bits) - 1);
+  unsigned char *data = (unsigned char *)bitmap;
+  unsigned data_size = width * height * 2;
+#define SWAP(a, b)                                                             \
+  {                                                                            \
+    a ^= b;                                                                    \
+    a ^= (b ^= a);                                                             \
+  }
+  for (unsigned i = 0; i < data_size; i += 2)
+    SWAP(data[i], data[i + 1]);
+#undef SWAP
+  fwrite(data, data_size, 1, f);
+  fclose(f);
+}
+
+/*  == gamma curve and tiff writer - simplified cut'n'paste from dcraw.c */
+
+#define SQR(x) ((x) * (x))
+
+void gamma_curve(unsigned short *curve)
+{
+
+  double pwr = 1.0 / 2.2;
+  double ts = 0.0;
+  int imax = 0xffff;
+  int mode = 2;
+  int i;
+  double g[6], bnd[2] = {0, 0}, r;
+
+  g[0] = pwr;
+  g[1] = ts;
+  g[2] = g[3] = g[4] = 0;
+  bnd[g[1] >= 1] = 1;
+  if (g[1] && (g[1] - 1) * (g[0] - 1) <= 0)
+  {
+    for (i = 0; i < 48; i++)
+    {
+      g[2] = (bnd[0] + bnd[1]) / 2;
+      if (g[0])
+        bnd[(pow(g[2] / g[1], -g[0]) - 1) / g[0] - 1 / g[2] > -1] = g[2];
+      else
+        bnd[g[2] / exp(1 - 1 / g[2]) < g[1]] = g[2];
+    }
+    g[3] = g[2] / g[1];
+    if (g[0])
+      g[4] = g[2] * (1 / g[0] - 1);
+  }
+  if (g[0])
+    g[5] = 1 / (g[1] * SQR(g[3]) / 2 - g[4] * (1 - g[3]) +
+                (1 - pow(g[3], 1 + g[0])) * (1 + g[4]) / (1 + g[0])) -
+           1;
+  else
+    g[5] = 1 / (g[1] * SQR(g[3]) / 2 + 1 - g[2] - g[3] -
+                g[2] * g[3] * (log(g[3]) - 1)) -
+           1;
+  for (i = 0; i < 0x10000; i++)
+  {
+    curve[i] = 0xffff;
+    if ((r = (double)i / imax) < 1)
+      curve[i] =
+          0x10000 *
+          (mode ? (r < g[3] ? r * g[1]
+                            : (g[0] ? pow(r, g[0]) * (1 + g[4]) - g[4]
+                                    : log(r) * g[2] + 1))
+                : (r < g[2] ? r / g[1]
+                            : (g[0] ? pow((r + g[4]) / (1 + g[4]), 1 / g[0])
+                                    : exp((r - 1) / g[2]))));
+  }
+}
+
+void tiff_set(ushort *ntag, ushort tag, ushort type, int count, int val)
+{
+  struct libraw_tiff_tag *tt;
+  int c;
+
+  tt = (struct libraw_tiff_tag *)(ntag + 1) + (*ntag)++;
+  tt->tag = tag;
+  tt->type = type;
+  tt->count = count;
+  if ((type < LIBRAW_EXIFTAG_TYPE_SHORT) && (count <= 4))
+    for (c = 0; c < 4; c++)
+      tt->val.c[c] = val >> (c << 3);
+  else if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_SHORT) && (count <= 2))
+    for (c = 0; c < 2; c++)
+      tt->val.s[c] = val >> (c << 4);
+  else
+    tt->val.i = val;
+}
+#define TOFF(ptr) ((char *)(&(ptr)) - (char *)th)
+
+void tiff_head(int width, int height, struct tiff_hdr *th)
+{
+  int c;
+  time_t timestamp = time(NULL);
+  struct tm *t;
+
+  memset(th, 0, sizeof *th);
+  th->t_order = htonl(0x4d4d4949) >> 16;
+  th->magic = 42;
+  th->ifd = 10;
+  tiff_set(&th->ntag, 254, 4, 1, 0);
+  tiff_set(&th->ntag, 256, 4, 1, width);
+  tiff_set(&th->ntag, 257, 4, 1, height);
+  tiff_set(&th->ntag, 258, 3, 1, 16);
+  for (c = 0; c < 4; c++)
+    th->bps[c] = 16;
+  tiff_set(&th->ntag, 259, 3, 1, 1);
+  tiff_set(&th->ntag, 262, 3, 1, 1);
+  tiff_set(&th->ntag, 273, 4, 1, sizeof *th);
+  tiff_set(&th->ntag, 277, 3, 1, 1);
+  tiff_set(&th->ntag, 278, 4, 1, height);
+  tiff_set(&th->ntag, 279, 4, 1, height * width * 2);
+  tiff_set(&th->ntag, 282, 5, 1, TOFF(th->rat[0]));
+  tiff_set(&th->ntag, 283, 5, 1, TOFF(th->rat[2]));
+  tiff_set(&th->ntag, 284, 3, 1, 1);
+  tiff_set(&th->ntag, 296, 3, 1, 2);
+  tiff_set(&th->ntag, 306, 2, 20, TOFF(th->date));
+  th->rat[0] = th->rat[2] = 300;
+  th->rat[1] = th->rat[3] = 1;
+  t = localtime(&timestamp);
+  if (t)
+    sprintf(th->date, "%04d:%02d:%02d %02d:%02d:%02d", t->tm_year + 1900,
+            t->tm_mon + 1, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec);
+}
+
+void write_tiff(int width, int height, unsigned short *bitmap, const char *fn)
+{
+  struct tiff_hdr th;
+
+  FILE *ofp = fopen(fn, "wb");
+  if (!ofp)
+    return;
+  tiff_head(width, height, &th);
+  fwrite(&th, sizeof th, 1, ofp);
+  fwrite(bitmap, 2, width * height, ofp);
+  fclose(ofp);
 }
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/Makefile libkdcraw/libkdcraw/libraw/src/Makefile
--- libkdcraw-wrk/libkdcraw/libraw/src/Makefile	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/Makefile	2022-11-07 07:46:31.642795007 +0300
@@ -0,0 +1,2 @@
+all:
+	(cd ..; make library)
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/decoders/canon_600.cpp libkdcraw/libkdcraw/libraw/src/decoders/canon_600.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/decoders/canon_600.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/decoders/canon_600.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -0,0 +1,224 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::canon_600_fixed_wb(int temp)
+{
+  static const short mul[4][5] = {{667, 358, 397, 565, 452},
+                                  {731, 390, 367, 499, 517},
+                                  {1119, 396, 348, 448, 537},
+                                  {1399, 485, 431, 508, 688}};
+  int lo, hi, i;
+  float frac = 0;
+
+  for (lo = 4; --lo;)
+    if (*mul[lo] <= temp)
+      break;
+  for (hi = 0; hi < 3; hi++)
+    if (*mul[hi] >= temp)
+      break;
+  if (lo != hi)
+    frac = (float)(temp - *mul[lo]) / (*mul[hi] - *mul[lo]);
+  for (i = 1; i < 5; i++)
+    pre_mul[i - 1] = 1 / (frac * mul[hi][i] + (1 - frac) * mul[lo][i]);
+}
+
+/* Return values:  0 = white  1 = near white  2 = not white */
+int LibRaw::canon_600_color(int ratio[2], int mar)
+{
+  int clipped = 0, target, miss;
+
+  if (flash_used)
+  {
+    if (ratio[1] < -104)
+    {
+      ratio[1] = -104;
+      clipped = 1;
+    }
+    if (ratio[1] > 12)
+    {
+      ratio[1] = 12;
+      clipped = 1;
+    }
+  }
+  else
+  {
+    if (ratio[1] < -264 || ratio[1] > 461)
+      return 2;
+    if (ratio[1] < -50)
+    {
+      ratio[1] = -50;
+      clipped = 1;
+    }
+    if (ratio[1] > 307)
+    {
+      ratio[1] = 307;
+      clipped = 1;
+    }
+  }
+  target = flash_used || ratio[1] < 197 ? -38 - (398 * ratio[1] >> 10)
+                                        : -123 + (48 * ratio[1] >> 10);
+  if (target - mar <= ratio[0] && target + 20 >= ratio[0] && !clipped)
+    return 0;
+  miss = target - ratio[0];
+  if (abs(miss) >= mar * 4)
+    return 2;
+  if (miss < -20)
+    miss = -20;
+  if (miss > mar)
+    miss = mar;
+  ratio[0] = target - miss;
+  return 1;
+}
+
+void LibRaw::canon_600_auto_wb()
+{
+  int mar, row, col, i, j, st, count[] = {0, 0};
+  int test[8], total[2][8], ratio[2][2], stat[2];
+
+  memset(&total, 0, sizeof total);
+  i = canon_ev + 0.5;
+  if (i < 10)
+    mar = 150;
+  else if (i > 12)
+    mar = 20;
+  else
+    mar = 280 - 20 * i;
+  if (flash_used)
+    mar = 80;
+  for (row = 14; row < height - 14; row += 4)
+    for (col = 10; col < width; col += 2)
+    {
+      for (i = 0; i < 8; i++)
+        test[(i & 4) + FC(row + (i >> 1), col + (i & 1))] =
+            BAYER(row + (i >> 1), col + (i & 1));
+      for (i = 0; i < 8; i++)
+        if (test[i] < 150 || test[i] > 1500)
+          goto next;
+      for (i = 0; i < 4; i++)
+        if (abs(test[i] - test[i + 4]) > 50)
+          goto next;
+      for (i = 0; i < 2; i++)
+      {
+        for (j = 0; j < 4; j += 2)
+          ratio[i][j >> 1] =
+              ((test[i * 4 + j + 1] - test[i * 4 + j]) << 10) / test[i * 4 + j];
+        stat[i] = canon_600_color(ratio[i], mar);
+      }
+      if ((st = stat[0] | stat[1]) > 1)
+        goto next;
+      for (i = 0; i < 2; i++)
+        if (stat[i])
+          for (j = 0; j < 2; j++)
+            test[i * 4 + j * 2 + 1] =
+                test[i * 4 + j * 2] * (0x400 + ratio[i][j]) >> 10;
+      for (i = 0; i < 8; i++)
+        total[st][i] += test[i];
+      count[st]++;
+    next:;
+    }
+  if (count[0] | count[1])
+  {
+    st = count[0] * 200 < count[1];
+    for (i = 0; i < 4; i++)
+      pre_mul[i] = 1.0 / (total[st][i] + total[st][i + 4]);
+  }
+}
+
+void LibRaw::canon_600_coeff()
+{
+  static const short table[6][12] = {
+      {-190, 702, -1878, 2390, 1861, -1349, 905, -393, -432, 944, 2617, -2105},
+      {-1203, 1715, -1136, 1648, 1388, -876, 267, 245, -1641, 2153, 3921,
+       -3409},
+      {-615, 1127, -1563, 2075, 1437, -925, 509, 3, -756, 1268, 2519, -2007},
+      {-190, 702, -1886, 2398, 2153, -1641, 763, -251, -452, 964, 3040, -2528},
+      {-190, 702, -1878, 2390, 1861, -1349, 905, -393, -432, 944, 2617, -2105},
+      {-807, 1319, -1785, 2297, 1388, -876, 769, -257, -230, 742, 2067, -1555}};
+  int t = 0, i, c;
+  float mc, yc;
+
+  mc = pre_mul[1] / pre_mul[2];
+  yc = pre_mul[3] / pre_mul[2];
+  if (mc > 1 && mc <= 1.28 && yc < 0.8789)
+    t = 1;
+  if (mc > 1.28 && mc <= 2)
+  {
+    if (yc < 0.8789)
+      t = 3;
+    else if (yc <= 2)
+      t = 4;
+  }
+  if (flash_used)
+    t = 5;
+  for (raw_color = i = 0; i < 3; i++)
+    FORCC rgb_cam[i][c] = table[t][i * 4 + c] / 1024.0;
+}
+
+void LibRaw::canon_600_load_raw()
+{
+  uchar data[1120], *dp;
+  ushort *pix;
+  int irow, row;
+
+  for (irow = row = 0; irow < height; irow++)
+  {
+    checkCancel();
+    if (fread(data, 1, 1120, ifp) < 1120)
+      derror();
+    pix = raw_image + row * raw_width;
+    for (dp = data; dp < data + 1120; dp += 10, pix += 8)
+    {
+      pix[0] = (dp[0] << 2) + (dp[1] >> 6);
+      pix[1] = (dp[2] << 2) + (dp[1] >> 4 & 3);
+      pix[2] = (dp[3] << 2) + (dp[1] >> 2 & 3);
+      pix[3] = (dp[4] << 2) + (dp[1] & 3);
+      pix[4] = (dp[5] << 2) + (dp[9] & 3);
+      pix[5] = (dp[6] << 2) + (dp[9] >> 2 & 3);
+      pix[6] = (dp[7] << 2) + (dp[9] >> 4 & 3);
+      pix[7] = (dp[8] << 2) + (dp[9] >> 6);
+    }
+    if ((row += 2) > height)
+      row = 1;
+  }
+}
+
+void LibRaw::canon_600_correct()
+{
+  int row, col, val;
+  static const short mul[4][2] = {
+      {1141, 1145}, {1128, 1109}, {1178, 1149}, {1128, 1109}};
+
+  for (row = 0; row < height; row++)
+  {
+    checkCancel();
+    for (col = 0; col < width; col++)
+    {
+      if ((val = BAYER(row, col) - black) < 0)
+        val = 0;
+      val = val * mul[row & 3][col & 1] >> 9;
+      BAYER(row, col) = val;
+    }
+  }
+  canon_600_fixed_wb(1311);
+  canon_600_auto_wb();
+  canon_600_coeff();
+  maximum = (0x3ff - black) * 1109 >> 9;
+  black = 0;
+}
